/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.13 by edhill, Fri Oct 10 18:38:57 2003 UTC revision 1.95 by edhill, Thu Aug 5 16:04:32 2004 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17      RETVAL=$?      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18      if test "x${RETVAL}" = x0 ; then      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20          exit 99  }
21      fi  
22      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1  # Search for particular CPP #cmds associated with MPI
23      RETVAL=$?  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24      if test "x${RETVAL}" = x0 ; then  test_for_mpi_in_cpp_eeoptions() {
25          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"      cpp_options=$1
26          exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27      fi      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          printf "Error: In $file there is an illegal line: "
41          exit 99          grep -i "$strng" $file
42            return 1
43      fi      fi
44      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      return 0
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"  
         exit 99  
    fi  
45  }  }
46    
47  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
# Line 46  expand_pkg_groups() { Line 51  expand_pkg_groups() {
51      PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"      PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"
52      if test -r $PKG_GROUPS ; then      if test -r $PKG_GROUPS ; then
53          cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp          cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
54          cat ./p1.tmp | awk '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp          cat ./p1.tmp | $AWK '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
55          matched=0          matched=0
56          for i in $PACKAGES ; do          for i in $PACKAGES ; do
57              line=`grep "^ *$i" ./p2.tmp`              line=`grep "^ *$i" ./p2.tmp`
58              RETVAL=$?              RETVAL=$?
59              if test "x$RETVAL" = x0 ; then              if test "x$RETVAL" = x0 ; then
60                  matched=1                  matched=1
61                  replace=`echo $line | awk '{ $1=""; $2=""; print $0 }'`                  replace=`echo $line | $AWK '{ $1=""; $2=""; print $0 }'`
62                  echo "    replacing \"$i\" with: $replace"                  echo "    replacing \"$i\" with: $replace"
63                  new_packages="$new_packages $replace"                  new_packages="$new_packages $replace"
64              else              else
# Line 62  expand_pkg_groups() { Line 67  expand_pkg_groups() {
67          done          done
68          PACKAGES=$new_packages          PACKAGES=$new_packages
69          rm -f ./p[1,2].tmp          rm -f ./p[1,2].tmp
70            return $matched
71      else      else
72          echo "Warning: can't read package groups definition file: $PKG_GROUPS"          echo "Warning: can't read package groups definition file: $PKG_GROUPS"
73      fi      fi
74  }  }
75    
76    #  Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
77    #  cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
78    check_for_broken_Ff()  {
79        #  Do we have defaults for $FS and/or $FS90 ?
80        tfs=f
81        tfs9=f90
82        if test "x$FS" != x ; then
83            tfs="$FS"
84        fi
85        if test "x$FS90" != x ; then
86            tfs9="$FS90"
87        fi
88    
89        #  First check the ability to create a *.F/.f pair.
90        cat <<EOF >> genmake_hello.F
91          program hello
92          write(*,*) 'hi'
93          stop
94          end
95    EOF
96        cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
97        RETVAL=$?
98        if test "x$RETVAL" != x0 ; then
99            if test "x$FS" = x ; then
100                FS='for'
101                FS90='fr9'
102                check_for_broken_Ff
103            else
104                cat <<EOF 2>&1
105    ERROR: Your file system cannot distinguish between *.F and *.f files
106      (fails the "cp" test) and this program cannot find a suitable
107      replacement extension.  Please try a different build environment or
108      contact the <MITgcm-support@mitgcm.org> list for help.
109    
110    EOF
111                exit -1
112            fi
113            return
114        fi
115        rm -f genmake_hello.*
116    
117        #  Check the ability of ${MAKE} and ${LN} to use the current set
118        #  of extensions.
119        cat <<EOF >> genmake_hello.F
120          program hello
121          write(*,*) 'hi'
122          stop
123          end
124    EOF
125        test -f Makefile  &&  mv -f Makefile Makefile.bak
126        cat <<EOF >> Makefile
127    %.$tfs : %.F
128    .SUFFIXES:
129    genmake_hello.$tfs: genmake_hello.F
130            $LN genmake_hello.F genmake_hello.$tfs
131    EOF
132        $MAKE "genmake_hello."$tfs > /dev/null 2>&1
133        RETVAL=$?
134        if test "x$RETVAL" != x0 -o ! -f "genmake_hello."$tfs ; then
135            if test "x$FS" = x ; then
136                FS='for'
137                FS90='fr9'
138                check_for_broken_Ff
139            else
140                cat <<EOF 2>&1
141    ERROR: Your file system cannot distinguish between *.F and *.f files
142      (fails the "make/ln" test) and this program cannot find a suitable
143      replacement extension.  Please try a different build environment or
144      contact the <MITgcm-support@mitgcm.org> list for help.
145    
146    EOF
147                exit -1
148                return
149            fi
150        fi
151        rm -f genmake_hello.* Makefile
152        test -f Makefile  &&  mv -f Makefile.bak Makefile
153    
154        #  If we make it here, use the extensions
155        FS=$tfs
156        FS90=$tfs9
157        return
158    }
159    
160    
161    look_for_makedepend()  {
162    
163        #  The "original" makedepend is part of the Imake system that is
164        #  most often distributed with XFree86 or with an XFree86 source
165        #  package.  As a result, many machines (eg. generic Linux) do not
166        #  have a system-default "makedepend" available.  For those
167        #  systems, we have two fall-back options:
168        #
169        #    1) a makedepend implementation shipped with the cyrus-imapd
170        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
171        #
172        #    2) a known-buggy xmakedpend shell script
173        #
174        #  So the choices are, in order:
175        #
176        #    1) use the user-specified program
177        #    2) use a system-wide default
178        #    3) locally build and use the cyrus implementation
179        #    4) fall back to the buggy local xmakedpend script
180        #
181        if test "x${MAKEDEPEND}" = x ; then
182            which makedepend > /dev/null 2>&1
183            RV0=$?
184            cat <<EOF >> genmake_tc.f
185          program test
186          write(*,*) 'test'
187          stop
188          end
189    EOF
190            makedepend genmake_tc.f > /dev/null 2>&1
191            RV1=$?
192            if test "x${RV0}${RV1}" = x00 ; then
193                MAKEDEPEND=makedepend
194            else
195                echo "    a system-default makedepend was not found."
196                
197                #  Try to build the cyrus implementation
198                build_cyrus_makedepend
199                RETVAL=$?
200                if test "x$RETVAL" != x0 ; then
201                    MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
202                fi
203                rm -f ./genmake_cy_md
204            fi
205        else
206            #  echo "MAKEDEPEND=${MAKEDEPEND}"
207            echo "${MAKEDEPEND}" | grep -i cyrus > /dev/null 2>&1
208            RETVAL=$?
209            if test x"$RETVAL" = x0 ; then
210                build_cyrus_makedepend
211            fi
212        fi
213    }
214    
215    
216    build_cyrus_makedepend()  {
217        rm -f ./genmake_cy_md
218        (
219            cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
220                &&  ./configure > /dev/null 2>&1  \
221                &&  make > /dev/null 2>&1
222            if test -x ./makedepend.exe ; then
223                $LN ./makedepend.exe ./makedepend
224            fi
225            ./makedepend ifparser.c > /dev/null 2>&1  \
226                &&  echo "true"
227        ) > ./genmake_cy_md
228        grep true ./genmake_cy_md > /dev/null 2>&1
229        RETVAL=$?
230        rm -f ./genmake_cy_md
231        if test "x$RETVAL" = x0 ; then
232            MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
233            return 0
234        else
235            echo "WARNING: unable to build cyrus-imapd-makedepend"
236            return 1
237        fi
238    }
239    
240  # Guess possible config options for this host  # Guess possible config options for this host
241  find_possible_configs()  {  find_possible_configs()  {
242    
243      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
244      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
245      PLATFORM=`echo $tmp2 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
246        tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
247        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
248        tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
249        PLATFORM=$tmp3
250        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
251      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
252      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
 #     if test "x$OFLIST" = x ; then  
 #       echo "  No pre-defined options files were found matching this platform"  
 #       echo "  but examples for other platforms can be found in:"  
 #       echo "    $ROOTDIR/tools/build_options"  
 #     else  
 #       echo "  Options files (located in $ROOTDIR/tools/build_options) that"  
 #       echo "  may work with this machine are:"  
 #       for i in $OFLIST ; do  
 #           echo "    $i"  
 #       done  
 #     fi  
253            
254      echo "test" > test      echo "test" > test
255      ln -s ./test link      ln -s ./test link
# Line 103  find_possible_configs()  { Line 267  find_possible_configs()  {
267          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
268      fi      fi
269    
270      # look for possible fortran compilers      look_for_makedepend
271      tmp="$MITGCM_FC $FC g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"  
272        #================================================================
273        #  look for possible C compilers
274        tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"
275        p_CC=
276        for c in $tmp ; do
277            rm -f ./genmake_hello.c  ./genmake_hello
278            cat >> genmake_hello.c << EOF
279    #include <stdio.h>
280    int main(int argc, char **argv) {
281      printf("Hello!\n");
282      return 0;
283    }
284    EOF
285            $c -o genmake_hello genmake_hello.c > /dev/null 2>&1
286            RETVAL=$?
287            if test "x${RETVAL}" = x0 ; then
288                p_CC="$p_CC $c"
289            fi
290        done
291        rm -f ./genmake_hello.c ./genmake_hello
292        if test "x${p_CC}" = x ; then
293            cat 1>&2 <<EOF
294    
295    Error: No C compilers were found in your path.  Please specify one using:
296    
297        1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
298        2) the CC or MITGCM_CC environment variables.
299    
300    EOF
301            exit 1
302        else
303            echo "  The possible C compilers found in your path are:"
304            echo "   "$p_CC
305            if test "x$CC" = x ; then
306                CC=`echo $p_CC | $AWK '{print $1}'`
307                echo "  Setting C compiler to: "$CC
308            fi
309        fi
310    
311        #================================================================
312        #  look for possible FORTRAN compilers
313        tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
314      p_FC=      p_FC=
315      for c in $tmp ; do      for c in $tmp ; do
316          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 121  EOF Line 327  EOF
327              p_FC="$p_FC $c"              p_FC="$p_FC $c"
328          fi          fi
329      done      done
330        rm -f ./hello.f ./hello
331      if test "x${p_FC}" = x ; then      if test "x${p_FC}" = x ; then
332          cat 1>&2 <<EOF          cat 1>&2 <<EOF
333    
# Line 128  Error: No Fortran compilers were found i Line 335  Error: No Fortran compilers were found i
335    
336      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
337      2) a command-line option (eg. "-fc NAME"), or      2) a command-line option (eg. "-fc NAME"), or
338      3) the MITGCM_FC environment variable.      3) the FC or MITGCM_FC environment variables.
339    
340  EOF  EOF
341          exit 1          exit 1
# Line 136  EOF Line 343  EOF
343          echo "  The possible FORTRAN compilers found in your path are:"          echo "  The possible FORTRAN compilers found in your path are:"
344          echo "   "$p_FC          echo "   "$p_FC
345          if test "x$FC" = x ; then          if test "x$FC" = x ; then
346              FC=`echo $p_FC | awk '{print $1}'`              FC=`echo $p_FC | $AWK '{print $1}'`
347                echo "  Setting FORTRAN compiler to: "$FC
348          fi          fi
349      fi      fi
350    
351      for i in $p_FC ; do      if test "x$OPTFILE" = x ; then
352          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i          OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
353          if test -r $p_OF ; then          if test ! -r $OPTFILE ; then
354              OPTFILE=$p_OF               echo "  I looked for the file "$OPTFILE" but did not find it"
355              echo "  The options file:  $p_OF"          fi
356              echo "    appears to match so we'll use it."      fi
357              break  #    echo "  The options file:  $p_OF"
358          fi  #    echo "    appears to match so we'll use it."
359      done  #   for i in $p_FC ; do
360    #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
361    #if test -r $p_OF ; then
362    #    OPTFILE=$p_OF
363    #    echo "  The options file:  $p_OF"
364    #    echo "    appears to match so we'll use it."
365    #    break
366    #fi
367    #   done
368      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
369          cat 1>&2 <<EOF          cat 1>&2 <<EOF
370    
# Line 202  get_pdepend_list()  { Line 418  get_pdepend_list()  {
418      #  strip the comments and then convert the dependency file into      #  strip the comments and then convert the dependency file into
419      #  two arrays: PNAME, DNAME      #  two arrays: PNAME, DNAME
420      cat $1 | sed -e 's/#.*$//g' \      cat $1 | sed -e 's/#.*$//g' \
421          | awk 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
422          > ./.pd_tmp          > ./.pd_tmp
423      source ./.pd_tmp      . ./.pd_tmp
424      rm -f ./.pd_tmp      rm -f ./.pd_tmp
425    
426      echo -n "PNAME = "${}      printf "PNAME = "${}
427  }  }
428    
429    
430  #  Explain usage  #  Explain usage
431  usage()  {  usage()  {
432      echo  cat <<EOF
433      echo "Usage: "$0" [OPTIONS]"  
434      echo "  where [OPTIONS] can be:"  Usage: "$0" [OPTIONS]
435      echo    where [OPTIONS] can be:
436      echo "    -help | --help | -h | --h"  
437      echo "    -nooptfile | --nooptfile"      -help | --help | -h | --h
438      echo "      -optfile NAME | --optfile NAME | -of NAME | --of NAME"            Print this help message and exit.
439      echo "      -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME"  
440      echo "    -pdepend NAME | --pdepend NAME"      -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
441      echo "      -pdepend=NAME | --pdepend=NAME"        -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
442      echo "    -pdefault NAME | --pdefault NAME"            Use "NAME" as the adoptfile.  By default, the file at
443      echo "      -pdefault=NAME | --pdefault=NAME"            "tools/adjoint_options/adjoint_default" will be used.
444      echo "    -make NAME | -m NAME"  
445      echo "      --make=NAME | -m=NAME"      -nooptfile | --nooptfile
446      echo "    -makefile NAME | -mf NAME"        -optfile NAME | --optfile NAME | -of NAME | --of NAME
447      echo "      --makefile=NAME | -mf=NAME"        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
448      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"            Use "NAME" as the optfile.  By default, an attempt will be
449      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"            made to find an appropriate "standard" optfile in the
450      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"            tools/build_options/ directory.
451      echo "      -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME"  
452      echo "    -mods NAME | --mods NAME | -mo NAME | --mo NAME"      -pdepend NAME | --pdepend NAME
453      echo "      -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME"        -pdepend=NAME | --pdepend=NAME
454      echo "    -disable NAME | --disable NAME"            Get package dependency information from "NAME".
455      echo "      -disable=NAME | --disable=NAME"  
456      echo "    -enable NAME | --enable NAME"      -pdefault NAME | --pdefault NAME
457      echo "      -enable=NAME | --enable=NAME"        -pdefault=NAME | --pdefault=NAME
458      echo "    -standarddirs NAME | --standarddirs NAME"            Get the default package list from "NAME".
459      echo "      -standarddirs=NAME | --standarddirs=NAME"  
460      echo "    -noopt NAME | --noopt NAME"      -make NAME | -m NAME
461      echo "      -noopt=NAME | --noopt=NAME"        --make=NAME | -m=NAME
462  #    echo "    -cpp NAME | --cpp NAME"            Use "NAME" for the MAKE program. The default is "make" but
463  #    echo "      -cpp=NAME | --cpp=NAME"            many platforms, "gmake" is the preferred choice.
464      echo "    -fortran NAME | --fortran NAME | -fc NAME | --fc NAME"  
465      echo "      -fc=NAME | --fc=NAME"      -makefile NAME | -mf NAME
466      echo "    -[no]ieee | --[no]ieee"        --makefile=NAME | -mf=NAME
467      echo "    -[no]mpi | --[no]mpi"            Call the makefile "NAME".  The default is "Makefile".
468      echo "    -[no]jam | --[no]jam"  
469      echo      -makedepend NAME | -md NAME
470      echo "  and NAME is a string such as:"        --makedepend=NAME | -md=NAME
471      echo            Use "NAME" for the MAKEDEPEND program.
472      echo "    --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'"  
473      echo "    -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'"      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
474      echo "    -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
475      echo            Specify the location of the MITgcm ROOTDIR as "NAME".
476      echo "  which, depending upon your shell, may need to be single-quoted"            By default, genamke will try to find the location by
477      echo "  if it contains spaces, dashes, or other special characters."            looking in parent directories (up to the 5th parent).
478    
479        -mods NAME | --mods NAME | -mo NAME | --mo NAME
480          -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
481              Here, "NAME" specifies a list of directories that are
482              used for additional source code.  Files found in the
483              "mods list" are given preference over files of the same
484              name found elsewhere.
485    
486        -disable NAME | --disable NAME
487          -disable=NAME | --disable=NAME
488              Here "NAME" specifies a list of packages that we don't
489              want to use.  If this violates package dependencies,
490              genamke will exit with an error message.
491    
492        -enable NAME | --enable NAME
493          -enable=NAME | --enable=NAME
494              Here "NAME" specifies a list of packages that we wish
495              to specifically enable.  If this violates package
496              dependencies, genamke will exit with an error message.
497    
498        -standarddirs NAME | --standarddirs NAME
499          -standarddirs=NAME | --standarddirs=NAME
500              Here, "NAME" specifies a list of directories to be
501              used as the "standard" code.
502    
503        -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
504          -fc=NAME | --fc=NAME
505              Use "NAME" as the fortran compiler.  By default, genmake
506              will search for a working compiler by trying a list of
507              "usual suspects" such as g77, f77, etc.
508    
509        -cc NAME | --cc NAME | -cc=NAME | --cc=NAME
510              Use "NAME" as the C compiler.  By default, genmake
511              will search for a working compiler by trying a list of
512              "usual suspects" such as gcc, c89, cc, etc.
513    
514        -[no]ieee | --[no]ieee
515              Do or don't use IEEE numerics.  Note that this option
516              *only* works if it is supported by the OPTFILE that
517              is being used.
518    
519        -mpi | --mpi
520              Include MPI header files and link to MPI libraries
521        -mpi=PATH | --mpi=PATH
522              Include MPI header files and link to MPI libraries using MPI_ROOT
523              set to PATH. i.e. Include files from \$PATH/include, link to libraries
524              from \$PATH/lib and use binaries from \$PATH/bin.
525    
526        -bash NAME
527              Explicitly specify the Bourne or BASH shell to use
528    
529      While it is most often a single word, the "NAME" variables specified
530      above can in many cases be a space-delimited string such as:
531    
532        --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'
533        -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'
534        -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
535    
536      which, depending upon your shell, may need to be single-quoted.
537    
538      For more detailed genmake documentation, please see:
539    
540        http://mitgcm.org/devel_HOWTO/
541    
542    EOF
543    
544      exit 1      exit 1
545  }  }
546    
547  #eh3 # This is the generic configuration.  #  Build a CPP macro to automate calling C routines from FORTRAN
548  #eh3 set LN         = ( 'ln -s' )  get_fortran_c_namemangling()  {
549  #eh3 set CPP        = ( '/lib/cpp -P' )  
550  #eh3 set S64        = ( '$(TOOLSDIR)/set64bitConst.sh' )      #echo "FC_NAMEMANGLE = \"$FC_NAMEMANGLE\""
551  #eh3 set KPP        = (  )      if test ! "x$FC_NAMEMANGLE" = x ; then
552  #eh3 set FC         = ( 'f77' )          return 0
553  #eh3 set LINK       = $FC      fi
554  #eh3 set MAKEDEPEND = ( 'makedepend' )  
555  #eh3 set INCLUDES   = ( -I. )      default_nm="#define FC_NAMEMANGLE(X) X ## _"
556  #eh3 set FFLAGS     = (  )      
557  #eh3 set FOPTIM     = (  )      cat > genmake_test.c <<EOF
558  #eh3 set CFLAGS     = (  )  void tcall( char * string ) { tsub( string ); }
559  #eh3 set KFLAGS1    = (  )  EOF
560  #eh3 set KFLAGS2    = (  )      $MAKE genmake_test.o >> genmake_warnings 2>&1
561  #eh3 set LIBS       = (  )      RETVAL=$?
562  #eh3 set KPPFILES   = (  )      if test "x$RETVAL" != x0 ; then
563  #eh3 if (! $?NOOPTFILES ) set NOOPTFILES = (  )          FC_NAMEMANGLE=$default_nm
564  #eh3 if (! $?NOOPTFLAGS ) set NOOPTFLAGS = (  )          cat <<EOF>> genmake_errors
565    
566    WARNING: C test compile fails
567    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
568    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
569    EOF
570            return 1
571        fi
572        c_tcall=`nm genmake_test.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
573        RETVAL=$?
574        if test "x$RETVAL" != x0 ; then
575            FC_NAMEMANGLE=$default_nm
576            cat <<EOF>> genmake_warnings
577    
578    WARNING: The "nm" command failed.
579    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
580    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
581    EOF
582            return 1
583        fi
584        cat > genmake_tcomp.f <<EOF
585          subroutine tcall( string )
586          character*(*) string
587          call tsub( string )
588          end
589    EOF
590        $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1
591        RETVAL=$?
592        if test "x$RETVAL" != x0 ; then
593            FC_NAMEMANGLE=$default_nm
594            cat <<EOF>> genmake_warnings
595    
596    WARNING: FORTRAN test compile fails -- please see "genmake_errors"
597    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
598    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
599    EOF
600            return 1
601        fi
602        f_tcall=`nm genmake_tcomp.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
603        RETVAL=$?
604        if test "x$RETVAL" != x0 ; then
605            FC_NAMEMANGLE=$default_nm
606            cat <<EOF>> genmake_warnings
607    
608    WARNING: The "nm" command failed.
609    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
610    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
611    EOF
612            return 1
613        fi
614    
615        c_a=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
616        f_a=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
617        c_b=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
618        f_b=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
619    
620        nmangle="X"
621        if test "x$c_a" != "x$f_a" ; then
622            comm="echo x$f_a | sed -e 's|x$c_a||'"
623            a=`eval $comm`
624            nmangle="$a ## $nmangle"
625        fi
626        if test "x$c_b" != "x$f_b" ; then
627            comm="echo x$f_b | sed -e 's|x$c_b||'"
628            b=`eval $comm`
629            nmangle="$nmangle ## $b"
630        fi
631    
632        FC_NAMEMANGLE="#define FC_NAMEMANGLE(X)  $nmangle"
633    
634        #  cleanup the testing files
635        rm -f genmake_tcomp.* genmake_test.*
636    }
637    
638    
639    check_HAVE_CLOC()  {
640        get_fortran_c_namemangling
641        cat <<EOF > genmake_tc_1.c
642    $FC_NAMEMANGLE
643    #include <stdio.h>
644    #include <stdlib.h>
645    #include <unistd.h>
646    #include <assert.h>
647    #include <sys/time.h>
648    void FC_NAMEMANGLE(cloc) ( double *curtim )
649    {
650     struct timeval tv1;
651     gettimeofday(&tv1 , (void *)NULL );
652     *curtim =  (double)((tv1.tv_usec)+(tv1.tv_sec)*1.E6);
653     *curtim = *curtim/1.E6;
654    }
655    EOF
656        make genmake_tc_1.o >> genmake_tc.log 2>&1
657        RET_C=$?
658        cat <<EOF > genmake_tc_2.f
659          program hello
660          Real*8 wtime
661          external cloc
662          call cloc(wtime)
663          print *," HELLO WORLD", wtime
664          end program hello
665    EOF
666        $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1
667        RET_F=$?
668        test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1
669        RETVAL=$?
670        if test "x$RETVAL" = x0 ; then
671            HAVE_CLOC=t
672            DEFINES="$DEFINES -DHAVE_CLOC"
673        fi
674        rm -f genmake_tc*
675    }
676    
677    
678    check_netcdf_libs()  {
679        echo "" > genmake_tnc.log
680        cat <<EOF > genmake_tnc.for
681          program fgennc
682    #include "netcdf.inc"
683          integer iret, ncid, xid
684          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
685          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
686          iret = nf_def_dim(ncid, 'X', 11, xid)
687          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
688          iret = nf_close(ncid)
689          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
690          end
691    EOF
692        #echo "$CPP $DEFINES $INCLUDES"
693        $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \
694            &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1
695        RET_COMPILE=$?
696        test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
697        RETVAL=$?
698        if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
699            HAVE_NETCDF=t
700        else
701            # try again with "-lnetcdf" added to the libs
702            $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \
703                &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \
704                $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1
705            RET_COMPILE=$?
706            test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
707            RETVAL=$?
708            if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
709                LIBS="$LIBS -lnetcdf"
710                HAVE_NETCDF=t
711            else
712                cat genmake_tnc.log >> genmake_warnings
713            fi
714        fi
715        rm -f genmake_tnc*
716    }
717    
718    
719    
720    ###############################################################################
721    #   Sequential part of script starts here
722    ###############################################################################
723    
724  #  Set defaults here  #  Set defaults here
725  COMMANDL="$0 $@"  COMMANDL="$0 $@"
# Line 289  LN= Line 729  LN=
729  S64=  S64=
730  KPP=  KPP=
731  FC=  FC=
732    #CC=gcc
733    CPP=
734  LINK=  LINK=
735  DEFINES="-DWORDLENGTH=4"  DEFINES=
736  PACKAGES=  PACKAGES=
737  ENABLE=  ENABLE=
738  DISABLE=  DISABLE=
739  MAKEFILE=  MAKEFILE=
740  MAKEDEPEND=  #MAKEDEPEND=
741  PDEPEND=  PDEPEND=
742  DUMPSTATE=t  DUMPSTATE=t
743  PDEFAULT=  PDEFAULT=
# Line 306  FOPTIM= Line 748  FOPTIM=
748  CFLAGS=  CFLAGS=
749  KFLAGS1=  KFLAGS1=
750  KFLAGS2=  KFLAGS2=
751    #LDADD=
752  LIBS=  LIBS=
753  KPPFILES=  KPPFILES=
754  NOOPTFILES=  NOOPTFILES=
755  NOOPTFLAGS=  NOOPTFLAGS=
756    MPI=
757    MPIPATH=
758    
759    # DEFINES checked by test compilation
760    HAVE_SYSTEM=
761    HAVE_FDATE=
762    FC_NAMEMANGLE=
763    HAVE_CLOC=
764    HAVE_NETCDF=
765    HAVE_ETIME=
766    
767  MODS=  MODS=
768  TOOLSDIR=  TOOLSDIR=
769  SOURCEDIRS=  SOURCEDIRS=
770  INCLUDEDIRS=  INCLUDEDIRS=
771  STANDARDDIRS=  STANDARDDIRS="USE_THE_DEFAULT"
772    
773    G2ARGS=
774    BASH=
775  PWD=`pwd`  PWD=`pwd`
776  MAKE=make  MAKE=make
777    AWK=awk
778  THISHOSTNAME=`hostname`  THISHOSTNAME=`hostname`
779  THISCWD=`pwd`  THISCWD=`pwd`
780  THISDATE=`date`  THISDATE=`date`
# Line 331  IEEE= Line 787  IEEE=
787  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
788      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
789  fi  fi
790    FS=
791    FS90=
792    
793    AUTODIFF_PKG_USED=f
794    AD_OPTFILE=
795    TAF=
796    AD_TAF_FLAGS=
797    FTL_TAF_FLAGS=
798    SVD_TAF_FLAGS=
799    TAF_EXTRA=
800    TAMC=
801    AD_TAMC_FLAGS=
802    FTL_TAF_FLAGS=
803    SVD_TAMC_FLAGS=
804    TAMC_EXTRA=
805    
806    
807  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
808  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
809  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
810    
811  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
812  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
813  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
814  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
815  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
816    gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
817    
818  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6"  #  The following are all related to adjoint/tangent-linear stuff
819    gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
820    gm_s11="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
821    gm_s12="TAF_EXTRA TAMC_EXTRA"
822    
823    gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
824    gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
825    
826    cat <<EOF
827    
828    GENMAKE :
829    
830    A program for GENerating MAKEfiles for the MITgcm project.  For a
831    quick list of options, use "genmake -h" or for more detail see:
832    
833      http://mitgcm.org/devel_HOWTO/
834    
835    EOF
836    
 echo  
837  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
838  gm_local="genmake_local"  gm_local="genmake_local"
839  for i in . $MODS ; do  for i in . $MODS ; do
840      if test -r $i/$gm_local ; then      if test -r $i/$gm_local ; then
841          source $i/$gm_local          . $i/$gm_local
842          break          break
843      fi      fi
844  done  done
845  echo -n "  getting local config information:  "  printf "  getting local config information:  "
846  if test -e $gm_local ; then  if test -f $gm_local ; then
847      echo "using $gm_local"      echo "using $gm_local"
848      source $gm_local      . $gm_local
849      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
850      # echo "ENABLE=$ENABLE"      # echo "ENABLE=$ENABLE"
851  else  else
# Line 375  fi Line 863  fi
863  #   n=$(( $n + 1 ))  #   n=$(( $n + 1 ))
864  #done  #done
865  #parse_options  #parse_options
   
866  ac_prev=  ac_prev=
867  for ac_option ; do  for ac_option in $@ ; do
868    
869        G2ARGS="$G2ARGS \"$ac_option\""
870    
871      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
872      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
# Line 400  for ac_option ; do Line 889  for ac_option ; do
889          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
890              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
891                    
892            -adoptfile | --adoptfile | -adof | --adof)
893                ac_prev=AD_OPTFILE ;;
894            -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
895                AD_OPTFILE=$ac_optarg ;;
896            
897          -pdepend | --pdepend)          -pdepend | --pdepend)
898              ac_prev=PDEPEND ;;              ac_prev=PDEPEND ;;
899          -pdepend=* | --pdepend=*)          -pdepend=* | --pdepend=*)
# Line 415  for ac_option ; do Line 909  for ac_option ; do
909          -make=* | --make=* | -m=* | --m=*)          -make=* | --make=* | -m=* | --m=*)
910              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
911                    
912            -bash | --bash)
913                ac_prev=BASH ;;
914            -bash=* | --bash=*)
915                BASH=$ac_optarg ;;
916            
917            -makedepend | --makedepend | -md | --md)
918                ac_prev=MAKEDEPEND ;;
919            -makedepend=* | --makedepend=* | -md=* | --md=*)
920                MAKEDEPEND=$ac_optarg ;;
921            
922          -makefile | --makefile | -ma | --ma)          -makefile | --makefile | -ma | --ma)
923              ac_prev=MAKEFILE ;;              ac_prev=MAKEFILE ;;
924          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
925              MAKEFILE=$ac_optarg ;;              MAKEFILE=$ac_optarg ;;
926                    
927          -platform | --platform | -pl | --pl)          -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
928              ac_prev=PLATFORM ;;              echo "ERROR: The platform option has been removed.  Please specify"
929          -platform=* | --platform=* | -pl=* | --pl=*)              echo "  the build options using the \"optfile\" mechanism."
930              PLATFORM=$ac_optarg ;;              echo
931                usage
932                ;;
933                    
934          -rootdir | --rootdir | -rd | --rd)          -rootdir | --rootdir | -rd | --rd)
935              ac_prev=ROOTDIR ;;              ac_prev=ROOTDIR ;;
# Line 450  for ac_option ; do Line 956  for ac_option ; do
956          -standarddirs=* | --standarddirs=*)          -standarddirs=* | --standarddirs=*)
957              STANDARDDIRS=$ac_optarg ;;              STANDARDDIRS=$ac_optarg ;;
958    
         -noopt | --noopt)  
             ac_prev=NOOPT ;;  
         -noopt=* | --noopt=*)  
             NOOPT=$ac_optarg ;;  
           
959  #           -cpp | --cpp)  #           -cpp | --cpp)
960  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
961  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
962  #               CPP=$ac_optarg ;;  #               CPP=$ac_optarg ;;
963                        
964            -cc | --cc)
965                ac_prev=CC ;;
966            -cc=* | --cc=*)
967                CC=$ac_optarg ;;
968            
969          -fortran | --fortran | -fc | --fc)          -fortran | --fortran | -fc | --fc)
970              ac_prev=FC ;;              ac_prev=FC ;;
971          -fc=* | --fc=*)          -fc=* | --fc=*)
972              FC=$ac_optarg ;;              FC=$ac_optarg ;;
973                    
974            -fs | --fs)
975                ac_prev=FS ;;
976            -fs=* | --fs=*)
977                FS=$ac_optarg ;;
978            
979            -fs90 | --fs90)
980                ac_prev=FS90 ;;
981            -fs90=* | --fs90=*)
982                FS90=$ac_optarg ;;
983            
984          -ieee | --ieee)          -ieee | --ieee)
985              IEEE=true ;;              IEEE=true ;;
986          -noieee | --noieee)          -noieee | --noieee)
987              IEEE= ;;              IEEE= ;;
988            
989          -mpi | --mpi)          -mpi | --mpi)
990              MPI=true ;;              MPI=true ;;
991          -nompi | --nompi)          -mpi=* | --mpi=*)
992              MPI= ;;              MPIPATH=$ac_optarg
993                MPI=true ;;
994                    
995          -jam | --jam)  #       -jam | --jam)
996              JAM=1 ;;  #           JAM=1 ;;
997          -nojam | --nojam)  #       -nojam | --nojam)
998              JAM=0 ;;  #           JAM=0 ;;
999                    
1000          -ds | --ds)          -ds | --ds)
1001              DUMPSTATE=t ;;              DUMPSTATE=t ;;
1002                    
1003            -taf_extra | --taf_extra)
1004                ac_prev=TAF_EXTRA ;;
1005            -taf_extra=* | --taf_extra=*)
1006                TAF_EXTRA=$ac_optarg ;;
1007    
1008            -tamc_extra | --tamc_extra)
1009                ac_prev=TAMC_EXTRA ;;
1010            -tamc_extra=* | --tamc_extra=*)
1011                TAMC_EXTRA=$ac_optarg ;;
1012    
1013          -*)          -*)
1014              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
1015              usage              usage
# Line 510  if test -f ./.genmakerc ; then Line 1037  if test -f ./.genmakerc ; then
1037  fi  fi
1038    
1039  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1040      if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`
1041        if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
1042          ROOTDIR=".."          ROOTDIR=".."
1043      else      else
1044          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
1045              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
1046                  ROOTDIR=$d                  ROOTDIR=$d
1047                  echo -n "Warning:  ROOTDIR was not specified but there appears to be"                  printf "Warning:  ROOTDIR was not specified but there appears to be"
1048                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
1049                  break                  break
1050              fi              fi
# Line 547  fi Line 1075  fi
1075  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
1076      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
1077          echo "    using OPTFILE=\"$OPTFILE\""          echo "    using OPTFILE=\"$OPTFILE\""
1078          source "$OPTFILE"          . "$OPTFILE"
1079          RETVAL=$?          RETVAL=$?
1080          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1081              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              printf "Error: failed to source OPTFILE \"$OPTFILE\""
1082              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1083              exit 1              exit 1
1084          fi          fi
# Line 563  if test "x$OPTFILE" != xNONE ; then Line 1091  if test "x$OPTFILE" != xNONE ; then
1091      fi      fi
1092  fi  fi
1093    
1094  #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain  #  Check for broken systems that cannot correctly distinguish *.F and *.f files
1095  #  and abort!  # check_for_broken_Ff
1096    
1097    echo "  getting AD_OPTFILE information:  "
1098    if test "x${AD_OPTFILE}" = x ; then
1099        if test "x$MITGCM_AD_OF" = x ; then
1100            AD_OPTFILE=$ROOTDIR/tools/adjoint_options/adjoint_default
1101        else
1102            AD_OPTFILE=$MITGCM_AD_OF
1103        fi
1104    fi
1105    if test "x${AD_OPTFILE}" != xNONE ; then
1106        if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
1107            echo "    using AD_OPTFILE=\"$AD_OPTFILE\""
1108            . "$AD_OPTFILE"
1109            RETVAL=$?
1110            if test "x$RETVAL" != x0 ; then
1111                printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1112                echo "--please check that variable syntax is bash-compatible"
1113                exit 1
1114            fi
1115            if test "x$DUMPSTATE" != xf ; then
1116                cp -f $AD_OPTFILE "genmake_ad_optfile"
1117            fi
1118        else
1119            echo "Error: can't read AD_OPTFILE=\"$AD_OPTFILE\""
1120            exit 1
1121        fi
1122    fi
1123    
1124    #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1125    #  either set defaults or complain and abort!
1126    if test ! "x$BASH" = x ; then
1127        # add a trailing space so that it works within the Makefile syntax (see below)
1128        BASH="$BASH "
1129    fi
1130  if test "x$FC" = x ; then  if test "x$FC" = x ; then
1131      cat <<EOF 1>&2      cat <<EOF 1>&2
1132    
# Line 575  Error: no Fortran compiler: please speci Line 1137  Error: no Fortran compiler: please speci
1137  EOF  EOF
1138      exit 1      exit 1
1139  fi  fi
1140    if test "x$CC" = x ; then
1141        CC=cc
1142    #     cat <<EOF 1>&2
1143    # Error: no C compiler: please specify using one of the following:
1144    #   1) within the options file ("CC=...") as specified by "-of=OPTFILE"
1145    #   2) the "-cc=XXX" command-line option
1146    #   3) the "./genmake_local" file
1147    # EOF
1148    #     exit 1
1149    fi
1150  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
1151      LINK=$FC      LINK=$FC
1152  fi  fi
1153    if test "x$MAKE" = x ; then
1154        MAKE="make"
1155    fi
1156  if test "x$CPP" = x ; then  if test "x$CPP" = x ; then
1157      CPP="cpp"      CPP=cpp
1158  fi  fi
1159    #EH3 === UGLY ===
1160    #  The following is an ugly little hack to check for $CPP in /lib/ and
1161    #  it should eventually be replaced with a more general function that
1162    #  searches a combo of the user's path and a list of "usual suspects"
1163    #  to find the correct location for binaries such as $CPP.
1164    for i in " " "/lib/" ; do
1165        echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
1166    done
1167    #EH3 === UGLY ===
1168  echo "#define A a" | $CPP > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
1169  RETVAL=$?  RETVAL=$?
1170  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
# Line 590  Error: C pre-processor "$CPP" failed the Line 1174  Error: C pre-processor "$CPP" failed the
1174    
1175    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
1176    2) the "./genmake_local" file    2) the "./genmake_local" file
1177      3) with the CPP environment variable
1178    
1179  EOF  EOF
1180      exit 1      exit 1
1181  else  else
1182      rm -f test_cpp      rm -f test_cpp
1183  fi  fi
1184  if test "x$MAKEDEPEND" = x ; then  look_for_makedepend
1185      MAKEDEPEND=makedepend  if test "x$LN" = x ; then
1186        LN="ln -s"
1187    fi
1188    echo "test" > genmake_test_ln
1189    $LN genmake_test_ln genmake_tlink
1190    RETVAL=$?
1191    if test "x$RETVAL" != x0 ; then
1192        cat <<EOF 1>&2
1193    
1194    Error: The command "ln -s" failed -- please specify a working soft-link
1195      command in the optfile.
1196    
1197    EOF
1198        exit 1
1199    fi
1200    rm -f genmake_test_ln genmake_tlink
1201    
1202    #  Check for broken *.F/*.f handling and fix if possible
1203    check_for_broken_Ff
1204    
1205    if test ! "x$MPI" = x ; then
1206          echo "  Turning on MPI cpp macros"
1207          DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1208    fi
1209    
1210    printf "\n===  Checking system libraries  ===\n"
1211    printf "  Do we have the system() command using $FC...  "
1212    cat > genmake_tcomp.f <<EOF
1213          program hello
1214          call system('echo hi')
1215          end
1216    EOF
1217    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1218    RETVAL=$?
1219    if test "x$RETVAL" = x0 ; then
1220        HAVE_SYSTEM=t
1221        DEFINES="$DEFINES -DHAVE_SYSTEM"
1222        echo "yes"
1223    else
1224        HAVE_SYSTEM=
1225        echo "no"
1226    fi
1227    rm -f genmake_tcomp*
1228    
1229    printf "  Do we have the fdate() command using $FC...  "
1230    cat > genmake_tcomp.f <<EOF
1231          program hello
1232          CHARACTER(128) string
1233          string = ' '
1234          call fdate( string )
1235          print *, string
1236          end
1237    EOF
1238    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1239    RETVAL=$?
1240    if test "x$RETVAL" = x0 ; then
1241        HAVE_FDATE=t
1242        DEFINES="$DEFINES -DHAVE_FDATE"
1243        echo "yes"
1244    else
1245        HAVE_FDATE=
1246        echo "no"
1247    fi
1248    rm -f genmake_tcomp*
1249    
1250    printf "  Do we have the etime() command using $FC...  "
1251    cat > genmake_tcomp.f <<EOF
1252          program hello
1253          REAL*4 ACTUAL, TARRAY(2)
1254          EXTERNAL ETIME
1255          REAL*4 ETIME
1256          actual = etime( tarray )
1257          print *, tarray
1258          end
1259    EOF
1260    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1261    RETVAL=$?
1262    if test "x$RETVAL" = x0 ; then
1263        HAVE_ETIME=t
1264        DEFINES="$DEFINES -DHAVE_ETIME"
1265        echo "yes"
1266    else
1267        HAVE_ETIME=
1268        echo "no"
1269    fi
1270    rm -f genmake_tcomp*
1271    
1272    printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1273    check_HAVE_CLOC
1274    if test "x$HAVE_CLOC" != x ; then
1275        echo "yes"
1276    else
1277        echo "no"
1278    fi
1279    rm -f genmake_t*
1280    
1281    printf "  Can we create NetCDF-enabled binaries...  "
1282    check_netcdf_libs
1283    if test "x$HAVE_NETCDF" != x ; then
1284        echo "yes"
1285    else
1286        echo "no"
1287  fi  fi
1288    
1289    
1290  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1291  echo -n "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1292  for d in $MODS ; do  for d in $MODS ; do
1293      if test ! -d $d ; then      if test ! -d $d ; then
1294          echo          echo
1295          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1296          exit 1          exit 1
1297      else      else
1298          echo -n " $d"          printf " $d"
1299          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1300          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1301      fi      fi
# Line 623  if test "x${PLATFORM}" = x ; then Line 1310  if test "x${PLATFORM}" = x ; then
1310  fi  fi
1311    
1312  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
1313      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`
1314        if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1315          EXEDIR=../exe          EXEDIR=../exe
1316      else      else
1317          EXEDIR=.          EXEDIR=.
# Line 638  if test "x${TOOLSDIR}" = x ; then Line 1326  if test "x${TOOLSDIR}" = x ; then
1326      TOOLSDIR="$ROOTDIR/tools"      TOOLSDIR="$ROOTDIR/tools"
1327  fi  fi
1328  if test ! -d ${TOOLSDIR} ; then  if test ! -d ${TOOLSDIR} ; then
1329      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1330      exit 1      exit 1
1331  fi  fi
1332  if test "x$S64" = x ; then  if test "x$S64" = x ; then
1333      S64='$(TOOLSDIR)/set64bitConst.sh'      S64='$(TOOLSDIR)/set64bitConst.sh'
1334  fi  fi
1335    THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1336    
1337  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1338    
# Line 652  EXECUTABLE=${EXECUTABLE:-mitgcmuv} Line 1341  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1341  #  they appear as regular source code  #  they appear as regular source code
1342  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
1343      echo "  Making source files in eesupp from templates"      echo "  Making source files in eesupp from templates"
1344      $MAKE -C $ROOTDIR"/eesupp/src/" > make_eesupp.errors 2>&1      ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
1345      RETVAL=$?      RETVAL=$?
1346      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
1347          rm -f make_eesupp.errors          rm -f make_eesupp.errors
1348      else      else
1349          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
1350          cat make_eesupp.errors          cat make_eesupp.errors 1>&2
1351          exit 1          exit 1
1352      fi      fi
1353  fi  fi
1354    
1355    #same for exch2
1356    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1357        echo "  Making source files in exch2 from  templates"
1358        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1359        RETVAL=$?
1360        if test "x${RETVAL}" = x0 ; then
1361            rm -f make_exch2.errors
1362        else
1363            echo "Error: problem encountered while building source files in exch2:"
1364            cat make_exch2.errors 1>&2
1365            exit 1
1366        fi
1367    fi
1368    
1369  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1370  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1371      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 682  echo "  getting package dependency info Line 1385  echo "  getting package dependency info
1385  #  Strip the comments and then convert the dependency file into  #  Strip the comments and then convert the dependency file into
1386  #  two arrays: PNAME, DNAME  #  two arrays: PNAME, DNAME
1387  cat $PDEPEND | sed -e 's/#.*$//g' \  cat $PDEPEND | sed -e 's/#.*$//g' \
1388      | awk 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \      | $AWK 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \
1389      > ./.pd_tmp      > ./.pd_tmp
1390  RETVAL=$?  RETVAL=$?
1391  if test ! "x${RETVAL}" = x0 ; then  if test ! "x${RETVAL}" = x0 ; then
1392      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
1393      exit 1      exit 1
1394  fi  fi
1395  source ./.pd_tmp  . ./.pd_tmp
1396  rm -f ./.pd_tmp  rm -f ./.pd_tmp
1397    
1398  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
1399  #  file should eventually be added so that, for convenience, one can  #  file should eventually be added so that, for convenience, one can
1400  #  specify groups of packages using names like "ocean" and "atmosphere".  #  specify groups of packages using names like "ocean" and "atmosphere".
1401  echo  -n "  checking default package list:  "  echo "  checking default package list:  "
1402  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
1403      for i in "." $MODS ; do      for i in "." $MODS ; do
1404          if test -r $i"/packages.conf" ; then          if test -r $i"/packages.conf" ; then
# Line 708  if test "x${PDEFAULT}" = x ; then Line 1411  if test "x${PDEFAULT}" = x ; then
1411      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
1412  fi  fi
1413  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
1414      echo "default packages file disabled"      echo "    default packages file disabled"
1415  else  else
1416      if test ! -r $PDEFAULT ; then      if test ! -r $PDEFAULT ; then
         echo ""  
1417          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""
1418      else      else
1419          echo "  using PDEFAULT=\"$PDEFAULT\""          echo "    using PDEFAULT=\"$PDEFAULT\""
1420          #  Strip the comments and add all the names          #  Strip the comments and add all the names
1421          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | awk '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1422          RETVAL=$?          RETVAL=$?
1423          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1424              echo -n "Error: can't parse default package list "              printf "Error: can't parse default package list "
1425              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PDEFAULT=\"$PDEFAULT\""
1426              exit 1              exit 1
1427          fi          fi
# Line 727  else Line 1429  else
1429              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1430          done          done
1431          echo "    before group expansion packages are: $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1432          expand_pkg_groups          RET=1
1433            while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1434          echo "    after group expansion packages are:  $PACKAGES"          echo "    after group expansion packages are:  $PACKAGES"
1435      fi      fi
1436  fi  fi
1437    
1438  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1439    for i in $PACKAGES ; do
1440        echo $i >> ./.tmp_pack
1441    done
1442    for i in `grep  "-" ./.tmp_pack` ; do
1443        j=`echo $i | sed 's/[-]//'`
1444        DISABLE="$DISABLE $j"
1445    done
1446  pack=  pack=
1447  for p in $PACKAGES ; do  for p in $PACKAGES ; do
1448      addit="t"      addit="t"
# Line 749  PACKAGES="$pack" Line 1459  PACKAGES="$pack"
1459  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1460  echo "" > ./.tmp_pack  echo "" > ./.tmp_pack
1461  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1462    # Test if each explicitly referenced package exists
1463  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1464      if test ! -d "$ROOTDIR/pkg/$i" ; then      j=`echo $i | sed 's/[-+]//'`
1465        if test ! -d "$ROOTDIR/pkg/$j" ; then
1466          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1467          exit 1          exit 1
1468      fi      fi
1469      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
1470  done  done
 pack=`cat ./.tmp_pack | sort | uniq`  
 rm -f ./.tmp_pack  
1471  PACKAGES=  PACKAGES=
1472  for i in $pack ; do  for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1473      PACKAGES="$PACKAGES $i"      PACKAGES="$PACKAGES $i"
1474  done  done
1475    rm -f ./.tmp_pack
1476  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1477    
1478  echo "  applying package dependency rules"  echo "  applying package dependency rules"
# Line 828  while test "x$ck" != xtt ; do Line 1539  while test "x$ck" != xtt ; do
1539              echo "  the dependency rules for \"$dname\""              echo "  the dependency rules for \"$dname\""
1540              exit 1              exit 1
1541          fi          fi
1542          i=$(( $i + 1 ))          i=`echo "$i + 1" | bc -l`
1543            #i=$(( $i + 1 ))
1544      done      done
1545      ck=$ck"t"      ck=$ck"t"
1546  done  done
# Line 838  for i in $PACKAGES ; do Line 1550  for i in $PACKAGES ; do
1550      if test -d $adr ; then      if test -d $adr ; then
1551          SOURCEDIRS="$SOURCEDIRS $adr"          SOURCEDIRS="$SOURCEDIRS $adr"
1552          INCLUDEDIRS="$INCLUDEDIRS $adr"          INCLUDEDIRS="$INCLUDEDIRS $adr"
1553            if test "x$i" = xautodiff ; then
1554                AUTODIFF_PKG_USED=t
1555            fi
1556      else      else
1557          echo "Error: the directory \"$adr\" for package $i doesn't exist"          echo "Error: the directory \"$adr\" for package $i doesn't exist"
1558          exit 1          exit 1
1559      fi      fi
1560  done  done
1561    
1562  #  This is compatible with the old genmake.  The "DISABLE_*" flags  #  Build MNC templates and check for ability to build and use NetCDF
1563  #  need to be replaced by the "ALLOW_*" flags set below.  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1564  #  RETVAL=$?
1565  # echo -n "  Setting package-specific CPP flags:  "  if test "x$RETVAL" = x0 ; then
1566  # pkrm=( mom_fluxform mom_vecinv generic_advdiff )      ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1
1567  # pkrmdef=( -DDISABLE_MOM_FLUXFORM -DDISABLE_MOM_VECINV -DDISABLE_GENERIC_ADVDIFF -DDISABLE_DEBUGMODE )      RETVAL=$?
1568  # echo -n "  "      if test "x${RETVAL}" = x0 ; then
1569  # i=0          rm -f make_mnc.errors
1570  # while test $i -lt "${#pkrm[@]}" ; do      else
1571  #     echo "$PACKAGES" | grep "${pk[$i]}" > /dev/null 2>&1          echo "Error: problem encountered while building source files in pkg/mnc:"
1572  #     RETVAL=$?          cat make_mnc.errors 1>&2
1573  #     if test "x$RETVAL" = x1 ; then          exit 1
1574  #       DEFINES="$DEFINES ${pkdef[$i]}"      fi
1575  #       echo -n " ${pkdef[$i]}"      if test "x$HAVE_NETCDF" != xt ; then
1576  #     fi          cat <<EOF
 #     i=$(( $i + 1 ))  
 # done  
 # echo  
   
 # Create a list of #define and #undef to enable/disable packages  
 PACKAGES_DOT_H=PACKAGES_CONFIG.h  
 cat <<EOF >$PACKAGES_DOT_H".tmp"  
 C=== GENMAKE v2 ===  
 C  The following defines have been set by GENMAKE, so please do not  
 C  edit anything below these comments.  In general, you should  
 C  add or remove packages by re-running genmake with different  
 C  "-enable" and/or "-disable" options.  
1577    
1578  #ifndef PACKAGES_H  WARNING: the "mnc" package has been enabled but tests failed to
1579  #define PACKAGES_H    compile and/or execute NetCDF applications.  Please check that:
1580    
1581  C  Packages disabled by genmake:    1) NetCDF is installed for your compiler and
1582      2) the LIBS variable (within the 'optfile") specifies the correct
1583           NetCDF library to link against.
1584      
1585  EOF  EOF
1586        fi
1587    fi
1588    
1589    # Create a list of #define and #undef to enable/disable packages
1590    PACKAGES_DOT_H=PACKAGES_CONFIG.h
1591  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
1592  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
1593  #  file would eventually be split up so that all package-related #define  #  file would eventually be split up so that all package-related #define
1594  #  statements could be separated and handled only by genmake.  #  statements could be separated and handled only by genmake.
1595  names=`ls -1 "$ROOTDIR/pkg"`  names=`ls -1 "$ROOTDIR/pkg"`
1596  all_pack=  all_pack=
1597    DISABLED_PACKAGES=
1598  for n in $names ; do  for n in $names ; do
1599      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
1600          has_pack="f"          has_pack="f"
# Line 893  for n in $names ; do Line 1605  for n in $names ; do
1605              fi              fi
1606          done          done
1607          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1608              undef=`echo "ALLOW_$n" | awk '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1609              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
 #           DEFINES="$DEFINES -U$undef"  
   
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
             case $n in  
                 mom_fluxform)  
                     DEFINES="$DEFINES -DDISABLE_MOM_FLUXFORM"  
                     ;;  
                 mom_vecinv)  
                     DEFINES="$DEFINES -DDISABLE_MOM_VECINV"  
                     ;;  
                 debug)  
                     DEFINES="$DEFINES -DDISABLE_DEBUGMODE"  
                     ;;  
             esac  
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
   
1610          fi          fi
1611      fi      fi
1612  done  done
1613  cat <<EOF >>$PACKAGES_DOT_H".tmp"  ENABLED_PACKAGES=
   
 C  Packages enabled by genmake:  
 EOF  
1614  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1615      def=`echo "ALLOW_$i" | awk '{print toupper($0)}'`      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1616      echo "#define $def" >> $PACKAGES_DOT_H".tmp"      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
1617  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
1618    
1619  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1620      case $i in      case $i in
1621          aim_v23)          aim_v23)
1622              echo "#define   ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1623              DEFINES="$DEFINES -DALLOW_AIM"              echo "Warning: ALLOW_AIM is set to enable aim_v23."
             echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"  
1624              ;;              ;;
1625      esac      esac
1626  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1627    
1628  done  done
 cat <<EOF >>$PACKAGES_DOT_H".tmp"  
   
 #endif /* PACKAGES_H */  
 EOF  
   
 if test ! -f $PACKAGES_DOT_H ; then  
     mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
 else  
     cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     RETVAL=$?  
     if test "x$RETVAL" = x0 ; then  
         rm -f $PACKAGES_DOT_H".tmp"  
     else  
         mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"  
         mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     fi  
 fi  
1629    
1630  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1631  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1632  if test "x$STANDARDDIRS" = x ; then  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1633      STANDARDDIRS="eesupp model"      STANDARDDIRS="eesupp model"
1634  fi  fi
1635  for d in $STANDARDDIRS ; do  if test "x$STANDARDDIRS" != x ; then
1636      adr="$ROOTDIR/$d/src"      for d in $STANDARDDIRS ; do
1637      if test ! -d $adr ; then          adr="$ROOTDIR/$d/src"
1638          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1639          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1640          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1641      else              exit 1
1642          SOURCEDIRS="$SOURCEDIRS $adr"          else
1643      fi              SOURCEDIRS="$SOURCEDIRS $adr"
1644      adr="$ROOTDIR/$d/inc"          fi
1645      if test ! -d $adr ; then          adr="$ROOTDIR/$d/inc"
1646          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1647          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1648          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1649      else              exit 1
1650          INCLUDEDIRS="$INCLUDEDIRS $adr"          else
1651      fi              INCLUDEDIRS="$INCLUDEDIRS $adr"
1652  done          fi
1653        done
1654    fi
1655    
1656  echo " Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1657  echo " of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define \"-type statements that are no longer allowed:"
1658  CPP_OPTIONS=  CPP_OPTIONS=
1659    CPP_EEOPTIONS=
1660  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1661    names=`ls -1 "$ROOTDIR/pkg"`
1662  for i in $spaths ; do  for i in $spaths ; do
1663      try="$i/CPP_OPTIONS.h"      try="$i/CPP_OPTIONS.h"
1664      #  echo -n "    trying $try : "      if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
     if test -f $try -a -r $try ; then  
1665          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1666          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
1667          break          # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1668            for n in $names ; do
1669                test_for_package_in_cpp_options $CPP_OPTIONS $n
1670            done
1671        fi
1672        try="$i/CPP_EEOPTIONS.h"
1673        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1674            echo "    found CPP_EEOPTIONS=\"$try\""
1675            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1676    #**** not yet enabled ****
1677    #        test_for_mpi_in_cpp_eeoptions $try
1678    #**** not yet enabled ****
1679            CPP_EEOPTIONS="$try"
1680      fi      fi
1681  done  done
1682  if test "x$CPP_OPTIONS" = x ; then  if test "x$CPP_OPTIONS" = x ; then
1683      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1684      exit 1      exit 1
1685  fi  fi
1686  # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h  
1687  names=`ls -1 "$ROOTDIR/pkg"`  #  Here, we build the list of files to be "run through" the adjoint
1688  for n in $names ; do  #  compiler.
1689      test_for_package_in_cpp_options $CPP_OPTIONS $n  if test -f ./ad_files ; then
1690        rm -f ./ad_files
1691    fi
1692    echo "  Creating the list of files for the adjoint compiler."
1693    for i in $SOURCEDIRS ; do
1694        list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
1695        for j in $list_files ; do
1696            cat $i/$j >> ad_files
1697        done
1698  done  done
1699    
1700    
# Line 1004  echo Line 1702  echo
1702  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1703  echo "  setting INCLUDES"  echo "  setting INCLUDES"
1704  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
1705      if ! test -d $i ; then      if test ! -d $i ; then
 #       INCLUDES="$INCLUDES -I$i"  
 #   else  
1706          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
1707      fi      fi
1708  done  done
# Line 1016  rm -rf .links.tmp Line 1712  rm -rf .links.tmp
1712  mkdir .links.tmp  mkdir .links.tmp
1713  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
1714  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
1715  echo -n 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
1716  echo -n 'CSRCFILES = '   > csrclist.inc  printf 'CSRCFILES = '   > csrclist.inc
1717  echo -n 'F90SRCFILES = ' > f90srclist.inc  printf 'F90SRCFILES = ' > f90srclist.inc
1718  echo -n 'HEADERFILES = ' > hlist.inc  printf 'HEADERFILES = ' > hlist.inc
1719    printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
1720  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1721  for d in $alldirs ; do  for d in $alldirs ; do
1722      deplist=      deplist=
1723      sfiles=`( cd $d; echo *.[h,c,F] )`      sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
1724      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
1725      for sf in $sfiles ; do      for sf in $sfiles ; do
1726          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1727              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1728                  extn=`echo $sf | awk -F '.' '{print $NF}'`                  case $d/$sf in
1729                  touch .links.tmp/$sf                    ./$PACKAGES_DOT_H)
1730                  deplist="$deplist $sf"                          ;;
1731                      ./AD_CONFIG.h)
1732                            ;;
1733                      ./FC_NAMEMANGLE.h)
1734                            ;;
1735                      *)
1736                            touch .links.tmp/$sf
1737                            deplist="$deplist $sf"
1738                            ;;
1739                    esac
1740                    extn=`echo $sf | $AWK -F '.' '{print $NF}'`
1741                  case $extn in                  case $extn in
1742                      F)                      F)
1743                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
1744                          echo -n " $sf" >> srclist.inc                          printf " $sf" >> srclist.inc
1745                          ;;                          ;;
1746                      F90)                      F90)
1747                          echo    " \\"  >> f90srclist.inc                          echo    " \\"  >> f90srclist.inc
1748                          echo -n " $sf" >> f90srclist.inc                          printf " $sf" >> f90srclist.inc
1749                          ;;                          ;;
1750                      c)                      c)
1751                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.inc
1752                          echo -n " $sf" >> csrclist.inc                          printf " $sf" >> csrclist.inc
1753                          ;;                          ;;
1754                      h)                      h)
1755                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1756                          echo -n " $sf" >> hlist.inc                          printf " $sf" >> hlist.inc
1757                            ;;
1758                        flow)
1759                            echo    " \\"  >> ad_flow_files.inc
1760                            printf " $sf" >> ad_flow_files.inc
1761                          ;;                          ;;
1762                  esac                  esac
1763              fi              fi
# Line 1064  echo "" >> srclist.inc Line 1775  echo "" >> srclist.inc
1775  echo "" >> csrclist.inc  echo "" >> csrclist.inc
1776  echo "" >> f90srclist.inc  echo "" >> f90srclist.inc
1777  echo "" >> hlist.inc  echo "" >> hlist.inc
1778    echo "" >> ad_flow_files.inc
1779    
1780  if test -e $MAKEFILE ; then  if test -f $MAKEFILE ; then
1781      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
1782  fi  fi
1783  echo "  Writing makefile: $MAKEFILE"  echo "  Writing makefile: $MAKEFILE"
# Line 1074  echo "#    $MACHINE" >> $MAKEFILE Line 1786  echo "#    $MACHINE" >> $MAKEFILE
1786  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
1787  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
1788  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
1789  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
1790  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1791  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE
1792    
1793    EXE_AD=$EXECUTABLE"_ad"
1794    EXE_FTL=$EXECUTABLE"_ftl"
1795    EXE_SVD=$EXECUTABLE"_svd"
1796    
1797  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1798    #
1799    # OPTFILE="$OPTFILE"
1800  #  #
1801  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1802  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 1105  EXEDIR      = ${EXEDIR} Line 1824  EXEDIR      = ${EXEDIR}
1824  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}
1825  TOOLSDIR    = ${TOOLSDIR}  TOOLSDIR    = ${TOOLSDIR}
1826    
1827    #eh3  new defines for the adjoint work
1828    AUTODIFF    = ${ROOTDIR}/pkg/autodiff
1829    EXE_AD      = ${EXE_AD}
1830    EXE_FTL     = ${EXE_FTL}
1831    EXE_SVD     = ${EXE_SVD}
1832    
1833    ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1834    DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1835    
1836    # These files are created by Makefile
1837    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h
1838    
1839  EOF  EOF
1840    
1841  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1122  KPP = ${KPP} Line 1853  KPP = ${KPP}
1853  FC = ${FC}  FC = ${FC}
1854  # Fortran compiler  # Fortran compiler
1855  F90C = ${F90C}  F90C = ${F90C}
1856    # C compiler
1857    CC = ${CC}
1858  # Link editor  # Link editor
1859  LINK = ${LINK}  LINK = ${LINK} ${LDADD}
1860    
1861  # Defines for CPP  # Defines for CPP
1862  DEFINES = ${DEFINES}  DEFINES = ${DEFINES}
# Line 1150  MAKEFILE=${MAKEFILE} Line 1883  MAKEFILE=${MAKEFILE}
1883    
1884  EOF  EOF
1885    
1886  cat srclist.inc    >> $MAKEFILE  cat srclist.inc       >> $MAKEFILE
1887  cat csrclist.inc   >> $MAKEFILE  cat csrclist.inc      >> $MAKEFILE
1888  cat f90srclist.inc >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1889  cat hlist.inc      >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1890  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
1891  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo >> $MAKEFILE
1892    echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
1893    echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE
1894  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1895    echo >> $MAKEFILE
1896    echo '.SUFFIXES:' >> $MAKEFILE
1897    echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
1898  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1899    rm -f ad_flow_files.inc
1900    
1901  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1902    
 .SUFFIXES:  
 .SUFFIXES: .o .f .p .F .c .F90 .f90  
   
1903  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1904  \$(EXECUTABLE): \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1905            @echo Creating \$@ ...
1906          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1907  depend:  depend:
1908          @make links          @make links
1909          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1910          ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1911            -rm -f makedepend.out
1912    
1913  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1914    
1915  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1916    
# Line 1182  output.txt: \$(EXECUTABLE) Line 1919  output.txt: \$(EXECUTABLE)
1919          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1920    
1921  clean:  clean:
1922          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
1923  Clean:  Clean:
1924          @make clean          @make clean
1925          @make cleanlinks          @make cleanlinks
1926          -rm -f Makefile.bak genmake_state genmake_optfile make.log          -rm -f \$(SPECIAL_FILES)
1927            -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1928  CLEAN:  CLEAN:
1929          @make Clean          @make Clean
1930          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1931          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1932          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1933          -rm -f \$(EXECUTABLE) output.txt          -rm -f \$(EXECUTABLE) output.txt STD*
1934    
1935    #eh3 Makefile: makefile
1936  makefile:  makefile:
1937          ${0} $@          $THIS_SCRIPT $G2ARGS
1938  cleanlinks:  cleanlinks:
1939          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1940    
1941  # The normal chain of rules is (  .F - .f - .o  )  # Special targets ($SPECIAL_FILES) which are create by make
1942  .F.f:  ${PACKAGES_DOT_H}:
1943            @echo Creating \$@ ...
1944            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1945    AD_CONFIG.h:
1946            @echo Creating \$@ ...
1947            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1948    FC_NAMEMANGLE.h:
1949            @echo Creating \$@ ...
1950            echo "$FC_NAMEMANGLE" > \$@
1951    
1952    # The normal chain of rules is (  .F - .$FS - .o  )
1953    
1954    %.o : %.F
1955    
1956    .F.$FS:
1957          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1958  .f.o:  .$FS.o:
1959          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
1960  .F90.f90:  .F90.$FS90:
1961          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1962  .f90.o:  .$FS90.o:
1963          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
1964  .c.o:  .c.o:
1965          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) -c \$<
1966    
1967  # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
1968  .F.p:  .F.p:
1969          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1970  .p.f:  .p.$FS:
1971          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1972    
1973    #=========================================
1974    #===  Automatic Differentiation Rules  ===
1975    
1976    TAMC           = ${TAMC}
1977    TAF            = ${TAF}
1978    
1979    TAF_EXTRA      = ${TAF_EXTRA}
1980    TAMC_EXTRA     = ${TAMC_EXTRA}
1981    
1982    EOF
1983    
1984    ad_vars="AD_TAMC_FLAGS AD_TAF_FLAGS"
1985    ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF_FLAGS"
1986    ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
1987    for i in $ad_vars ; do
1988        name=$i
1989        t1="t2=\$"`echo $i`
1990        eval $t1
1991        printf "%-20s = " $name >> $MAKEFILE
1992        echo $t2 >> $MAKEFILE
1993    done
1994    
1995    echo "  Add the source list for AD code generation"
1996    echo >> $MAKEFILE
1997    printf "AD_FILES = " >> $MAKEFILE
1998    AD_FILES=`cat ad_files`
1999    for i in $AD_FILES ; do
2000        echo    " \\" >> $MAKEFILE
2001        printf " $i" >> $MAKEFILE
2002    done
2003    echo >> $MAKEFILE
2004    rm -f ad_files
2005    
2006    cat >>$MAKEFILE <<EOF
2007    
2008    # ... AD ...
2009    adall: ad_taf
2010    adtaf: ad_taf_output.f
2011    adtamc: ad_tamc_output.f
2012    
2013    ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
2014            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2015            cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2016            -rm -f ad_config.template
2017            @make \$(F77FILES)
2018            @make \$(AD_FLOW_FILES)
2019            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
2020    
2021    ad_taf_output.f: ad_input_code.f
2022            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
2023            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
2024    
2025    adtafonly:
2026            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
2027            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
2028    
2029    ad_taf: ad_taf_output.o \$(OBJFILES)
2030            \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2031    
2032    ad_tamc_output.f: ad_input_code.f
2033            \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
2034            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f
2035    
2036    ad_tamc: ad_tamc_output.o \$(OBJFILES)
2037            \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
2038    
2039    
2040    # ... FTL ...
2041    ftlall: ftl_taf
2042    ftltaf: ftl_taf_output.f
2043    ftltamc: ftl_tamc_output.f
2044    
2045    ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
2046            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2047            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2048            -rm -f ftl_config.template
2049            @make \$(F77FILES)
2050            @make \$(AD_FLOW_FILES)
2051            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
2052    
2053    ftl_taf_output.f: ftl_input_code.f
2054            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
2055            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
2056    
2057    ftltafonly:
2058            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
2059            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
2060    
2061    ftl_taf: ftl_taf_output.o \$(OBJFILES)
2062            \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
2063    
2064    ftl_tamc_output.f: ftl_input_code.f
2065            \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
2066            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f
2067    
2068    ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2069            \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
2070    
2071    
2072    # ... SVD ...
2073    svdtaf: ad_taf_output.f ftl_taf_output.f
2074    svdall: svd_taf
2075    
2076    svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)
2077            \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
2078    
2079    
2080    #=========================================
2081    
2082  EOF  EOF
2083    
2084  if test "x$EXEHOOK" != x ; then  if test "x$EXEHOOK" != x ; then
# Line 1230  for i in $KPPFILES ; do Line 2092  for i in $KPPFILES ; do
2092      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2093          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2094      fi      fi
2095      echo "$base.f: $base.p" >> $MAKEFILE      echo "$base.$FS: $base.p" >> $MAKEFILE
2096  done  done
2097    
2098  echo "  Making list of NOOPTFILES"  echo "  Making list of NOOPTFILES"
# Line 1240  for i in $NOOPTFILES ; do Line 2102  for i in $NOOPTFILES ; do
2102      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2103          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2104      fi      fi
2105      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.$FS" >> $MAKEFILE
2106      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2107  done  done
2108    
# Line 1253  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 2115  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
2115    
2116  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
2117    
2118    # Create special header files
2119    $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
2120    if test ! -f $PACKAGES_DOT_H ; then
2121        mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2122    else
2123        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
2124        RETVAL=$?
2125        if test "x$RETVAL" = x0 ; then
2126            rm -f $PACKAGES_DOT_H".tmp"
2127        else
2128            mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
2129            mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2130        fi
2131    fi
2132    if test ! -f AD_CONFIG.h ; then
2133        $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
2134    fi
2135    
2136    
2137  #  Write the "state" for future records  #  Write the "state" for future records
2138  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
2139      echo -n "" > genmake_state      printf "" > genmake_state
2140      for i in $gm_state ; do      for i in $gm_state ; do
2141          t1="t2=\$$i"          t1="t2=\$$i"
2142          eval $t1          eval $t1

Legend:
Removed from v.1.13  
changed lines
  Added in v.1.95

  ViewVC Help
Powered by ViewVC 1.1.22